Package com.io7m.jtensors.core.unparameterized.vectors

# Class Vector2D.Builder

java.lang.Object
com.io7m.jtensors.core.unparameterized.vectors.Vector2D.Builder

Enclosing class:
  `Vector2D`

public static final class Vector2D.Builder extends Object
Builds instances of type `Vector2D`. Initialize attributes and then invoke the `build()` method to create an immutable instance.

`Builder` is not thread-safe and generally should not be stored in a field or collection, but instead used immediately to create instances.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `Vector2D`
  `build()`
  Builds a new `Vector2D`.
  `final Vector2D.Builder`
  `from(Vector2DType instance)`
  Fill a builder with attribute values from the provided `com.io7m.jtensors.core.unparameterized.vectors.Vector2DType` instance.
  `final Vector2D.Builder`
  `from(VectorReadable2DType instance)`
  Fill a builder with attribute values from the provided `com.io7m.jtensors.core.unparameterized.vectors.VectorReadable2DType` instance.
  `final Vector2D.Builder`
  `setX(double x)`
  Initializes the value for the `x` attribute.
  `final Vector2D.Builder`
  `setY(double y)`
  Initializes the value for the `y` attribute.

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Method Details

  - ### from

    public final Vector2D.Builder from(VectorReadable2DType instance)
    Fill a builder with attribute values from the provided `com.io7m.jtensors.core.unparameterized.vectors.VectorReadable2DType` instance.
    Parameters:
      `instance` - The instance from which to copy values
    Returns:
      `this` builder for use in a chained invocation

  - ### from

    public final Vector2D.Builder from(Vector2DType instance)
    Fill a builder with attribute values from the provided `com.io7m.jtensors.core.unparameterized.vectors.Vector2DType` instance.
    Parameters:
      `instance` - The instance from which to copy values
    Returns:
      `this` builder for use in a chained invocation

  - ### setX

    public final Vector2D.Builder setX(double x)
    Initializes the value for the `x` attribute.
    Parameters:
      `x` - The value for x
    Returns:
      `this` builder for use in a chained invocation

  - ### setY

    public final Vector2D.Builder setY(double y)
    Initializes the value for the `y` attribute.
    Parameters:
      `y` - The value for y
    Returns:
      `this` builder for use in a chained invocation

  - ### build

    public Vector2D build()
    Builds a new `Vector2D`.
    Returns:
      An immutable instance of Vector2D
    Throws:
      `IllegalStateException` - if any required attributes are missing